<?php
/*
	Project: Task Scheduler
	Author : karapuz <support@ka-station.com>

	Version: 3 ($Revision: 139 $)

	
*/
class ModelRefreshCurrencies extends \Model {

	public function getModuleName() {
		$name = 'Standard Opencart refresh currency routine';
		return $name;
	}
	
	/*
		This function is optional
	*/
	public function requestSchedulerOperations() {
	
		$ret = array(
			'refresh_currencies' => 'Refresh Currencies (Opencart Routine)'
		);
	
		return $ret;
	}

	/*
		This function is optional
	*/
	public function requestSchedulerOperationParams($op) {
	
		$ret = array(
/*		
			'page_url' => array(
				'title' => 'Page URL',
				'type'  => 'text',
				'required' => true,
			),
*/			
		);
		
		return $ret;
	}

	/*
		This function is mandatory
		
		$operation - operation name (string)
		$params    - array of parameters
		$stat      - array of returned strings for displaying results of the operation
		
		RETURNS:
			$return - text code (
					'finished'      - operation is complete
					'not_finished'  - still working (additional calls needed)
					)
			
			$return - array(
					'result'        - text code (finished/not_finished)
					'next_task_id'  - task_id to request on completion
	*/
	public function runSchedulerOperation($operation, $params, &$stat) {
	
			$return_code = 'finished';
			
			/* put your code below this line */		

			$this->load->model('localisation/currency');
			$updated_currencies = $this->model_localisation_currency->refresh(true);
			
			// return statistics
			//
			if (!empty($updated_currencies)) {
				$stat = array(
					'Updated currencies' => explode(', ', $updated_currencies),
				);
			}
			
			return $return_code;
	}
}

class_alias(__NAMESPACE__ . '\ModelRefreshCurrencies', 'ModelExtensionKaExtensionsTasksRefreshCurrencies');