<?php
/*
	Project: Task Scheduler
	Author : karapuz <support@ka-station.com>

	Version: 3 ($Revision: 139 $)

	
	Description:
	
		This is a sample task script which allows to create a new task for requesting any page URL.
		It can be used for calling other 3rd party scripts requiring periodical executions.
		
		The model shows mininum and required functions declared in 'Task Scheduler API'.
*/
class ModelRequestURL extends \Model {

	/*
		This function is optional
	*/
	public function requestSchedulerOperations() {
	
		$ret = array(
			'request_url' => 'Request page URL'
		);
	
		return $ret;
	}

	/*
		This function is optional
	*/
	public function requestSchedulerOperationParams($op) {
	
		$ret = array(
			'page_url' => array(
				'title' => 'Page URL',
				'type'  => 'text',
				'required' => true,
			),
		);
		
		return $ret;
	}

	/*
		This function is mandatory
		
		$operation - operation name (string)
		$params    - array of parameters
		$stat      - array of returned strings for displaying results of the operation
		
		RETURNS:
			$return - text code (
					'finished'      - operation is complete
					'not_finished'  - still working (additional calls needed)
					)
			
			$return - array(
					'result'        - text code (finished/not_finished)
					'next_task_id'  - task_id to request on completion
	*/
	public function runSchedulerOperation($operation, $params, &$stat) {
	
			$return_code = 'finished';
			
			/* put your code below this line */		

			$curl = new \KaCURL();
			$homepage = $curl->request($params['page_url']);
			
			/* some statistics can be returned in the stat array */
			$stat = array(
				'Page size (bytes)' => strlen($homepage),
			);
			
			return $return_code;
	}
}

class_alias(__NAMESPACE__ . '\ModelRequestURL', 'ModelExtensionKaExtensionsTasksRequestURL');